
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Table &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <h1>Source code for Table</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>

<div class="viewcode-block" id="table_from_report"><a class="viewcode-back" href="../sphinx/Report.html#Table.table_from_report">[docs]</a><span class="k">def</span> <span class="nf">table_from_report</span><span class="p">(</span><span class="n">file_name</span><span class="p">):</span>
    <span class="sd">&quot;&quot;&quot;Creates an Excel Spreadsheet with model performance from an analysis file</span>

<span class="sd">    The spreadsheet is saved in the respective report folder with the name of</span>
<span class="sd">    the analysis file.</span>

<span class="sd">    .. _Figure 0:</span>

<span class="sd">    .. figure:: Images/table_example.png</span>
<span class="sd">        :figwidth: 50 %</span>

<span class="sd">        Figure 0: Example of a table created with this function.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    file_name : str</span>
<span class="sd">        Name of the Analysis file (&quot;Analysis_Best.txt&quot;, &quot;Analysis_MIT.txt&quot; etc.)</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="n">file</span> <span class="o">=</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;r&#39;</span><span class="p">)</span>
        <span class="n">df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">()</span>

        <span class="n">line_list</span> <span class="o">=</span> <span class="n">file</span><span class="o">.</span><span class="n">readlines</span><span class="p">()</span>
        <span class="n">index</span> <span class="o">=</span> <span class="mi">0</span>
        <span class="n">train_list</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">while</span> <span class="kc">True</span><span class="p">:</span>
            <span class="n">b_index</span> <span class="o">=</span> <span class="n">line_list</span><span class="p">[</span><span class="n">index</span><span class="p">]</span><span class="o">.</span><span class="n">find</span><span class="p">(</span><span class="s1">&#39;B00&#39;</span><span class="p">)</span>
            <span class="n">battery_number</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="n">line_list</span><span class="p">[</span><span class="n">index</span><span class="p">][</span><span class="n">b_index</span><span class="o">+</span><span class="mi">1</span><span class="p">:</span><span class="n">b_index</span><span class="o">+</span><span class="mi">5</span><span class="p">])</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">battery_number</span><span class="p">)</span>
            <span class="k">if</span> <span class="n">line_list</span><span class="p">[</span><span class="n">index</span><span class="p">]</span><span class="o">.</span><span class="n">find</span><span class="p">(</span><span class="s1">&#39;training&#39;</span><span class="p">)</span> <span class="o">!=</span> <span class="o">-</span><span class="mi">1</span><span class="p">:</span>
                <span class="n">train_str</span> <span class="o">=</span> <span class="s1">&#39;Training&#39;</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="n">train_str</span> <span class="o">=</span> <span class="s1">&#39;Validation&#39;</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">train_str</span><span class="p">)</span>

            <span class="n">error_index</span> <span class="o">=</span> <span class="n">line_list</span><span class="p">[</span><span class="n">index</span><span class="o">+</span><span class="mi">4</span><span class="p">]</span><span class="o">.</span><span class="n">find</span><span class="p">(</span><span class="s1">&#39;:&#39;</span><span class="p">)</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">line_list</span><span class="p">[</span><span class="n">index</span> <span class="o">+</span> <span class="mi">4</span><span class="p">][</span><span class="n">error_index</span> <span class="o">+</span> <span class="mi">2</span><span class="p">:</span><span class="n">error_index</span> <span class="o">+</span> <span class="mi">6</span><span class="p">])</span>
            <span class="n">mean_error</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span>
                <span class="n">line_list</span><span class="p">[</span><span class="n">index</span> <span class="o">+</span> <span class="mi">4</span><span class="p">][</span><span class="n">error_index</span> <span class="o">+</span> <span class="mi">2</span><span class="p">:</span><span class="n">error_index</span> <span class="o">+</span> <span class="mi">6</span><span class="p">]</span>
            <span class="p">)</span> <span class="o">*</span> <span class="mf">1e-2</span>
            <span class="nb">print</span><span class="p">(</span><span class="n">line_list</span><span class="p">[</span><span class="n">index</span> <span class="o">+</span> <span class="mi">4</span><span class="p">][</span><span class="n">error_index</span> <span class="o">+</span> <span class="mi">9</span><span class="p">:</span><span class="n">error_index</span> <span class="o">+</span> <span class="mi">13</span><span class="p">])</span>
            <span class="n">max_error</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span>
                <span class="n">line_list</span><span class="p">[</span><span class="n">index</span> <span class="o">+</span> <span class="mi">4</span><span class="p">][</span><span class="n">error_index</span> <span class="o">+</span> <span class="mi">9</span><span class="p">:</span><span class="n">error_index</span> <span class="o">+</span> <span class="mi">13</span><span class="p">]</span>
            <span class="p">)</span> <span class="o">*</span> <span class="mf">1e-2</span>

            <span class="c1"># df_2 = pd.DataFrame(</span>
            <span class="c1">#     data = np.array([[battery_number, mean_error,</span>
            <span class="c1">#                       max_error, train_str]]),</span>
            <span class="c1">#     columns = [&#39;Battery Number&#39;, &#39;Mean error&#39;, &#39;Max error&#39;, &#39;Set&#39;]</span>
            <span class="c1"># )</span>

            <span class="n">df_2</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">(</span>
                <span class="n">data</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([[</span><span class="n">battery_number</span><span class="p">,</span> <span class="n">mean_error</span><span class="p">,</span>
                                <span class="n">max_error</span><span class="p">]]),</span>
                <span class="n">columns</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;Battery Number&#39;</span><span class="p">,</span> <span class="s1">&#39;Mean error&#39;</span><span class="p">,</span> <span class="s1">&#39;Max error&#39;</span><span class="p">]</span>
            <span class="p">)</span>

            <span class="n">train_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">train_str</span><span class="p">)</span>

            <span class="n">df</span> <span class="o">=</span> <span class="n">df</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">df_2</span><span class="p">)</span>

            <span class="n">index</span> <span class="o">+=</span> <span class="mi">7</span>
            <span class="k">if</span> <span class="n">index</span> <span class="o">&gt;=</span> <span class="nb">len</span><span class="p">(</span><span class="n">line_list</span><span class="p">):</span>
                <span class="k">break</span>

    <span class="k">finally</span><span class="p">:</span>
        <span class="n">file</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>
        <span class="n">df</span><span class="p">[</span><span class="s1">&#39;Set&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span><span class="n">train_list</span><span class="p">)</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">train_list</span><span class="p">),</span> <span class="mi">1</span><span class="p">)</span>
        <span class="k">with</span> <span class="n">pd</span><span class="o">.</span><span class="n">ExcelWriter</span><span class="p">(</span><span class="s1">&#39;Report&#39;</span><span class="o">+</span><span class="n">file_name</span><span class="o">+</span> <span class="s1">&#39;.xlsx&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">writer</span><span class="p">:</span>
            <span class="n">df</span><span class="o">.</span><span class="n">to_excel</span><span class="p">(</span><span class="n">writer</span><span class="p">,</span> <span class="n">sheet_name</span><span class="o">=</span><span class="n">file_name</span><span class="p">)</span></div>
</pre></div>

              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>